
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java的双缓冲技术 / iVAN</title>

    <meta name="description" content="java的双缓冲技术 Java的强大特性让其在游戏编程和多媒体动画处理方面也毫不逊色.在Java游戏编程和动画编程中最常见的就是对于屏幕闪烁的处理.本文从J2SE的一个再现了屏幕闪烁的Java Appilication简单动画实例展开,对屏幕闪烁的原因进行了分析,找出了闪烁成因的关键:update(Graphics g)函数对于前端屏幕的清屏.由此引出消除闪烁的方法--双缓冲.双缓冲是计算机动画处理中的传统技术,在用其他语言编程时也可以实现.本文从实例出发,着重介绍了用双缓冲消除闪烁的原理以及双缓冲在Java中的两种">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">java的双缓冲技术</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Java的强大特性让其在游戏编程和多媒体动画处理方面也毫不逊色。在Java游戏编程和动画编程中最常见的就是对于屏幕闪烁的处理。本文从J2SE的一个再现了屏幕闪烁的Java<br />
 Appilication简单动画实例展开，对屏幕闪烁的原因进行了分析，找出了闪烁成因的关键：update(Graphics g)函数对于前端屏幕的清屏。由此引出消除闪烁的方法——双缓冲。双缓冲是计算机动画处理中的传统技术，在用其他语言编程时也可以实现。本文从实例出发，着重介绍了用双缓冲消除闪烁的原理以及双缓冲在Java中的两种常用实现方法（即在update(Graphics<br />
 g)中实现和在paint(Graphics g)中实现），以期读者能对双缓冲在Java编程中的应用能有个较全面的认识。</p>
<p>一、问题的引入</p>
<p>在编写Java多媒体动画程序或用Java编写游戏程序的时候，我们得到的动画往往存在严重的闪烁（或图片断裂）。这种闪烁虽然不会给程序的效果造成太大的影响，但着实有违我们的设计初衷，也给程序的使用者造成了些许不便。闪烁到底是什么样的呢？下面的JavaApplication再现了这种屏幕闪烁的情况：</p>
<p>代码段一，闪烁再现</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>import java.awt.*;  </li>
<li>import java.awt.event.*;  </li>
<li>public class DoubleBuffer extends Frame//主类继承Frame类  </li>
<li>{  </li>
<li>    public paintThread pT;//绘图线程  </li>
<li>    public int ypos=-80; //小圆左上角的纵坐标  </li>
<li>    public DoubleBuffer()//构造函数  </li>
<li>    {  </li>
<li>       pT=new paintThread(this);  </li>
<li>       this.setResizable(false);  </li>
<li>       this.setSize(300,300); //设置窗口的首选大小  </li>
<li>       this.setVisible(true); //显示窗口  </li>
<li>       pT.start();//绘图线程启动  </li>
<li>    }  </li>
<li>   public void paint(Graphics scr) //重载绘图函数  </li>
<li>   {  </li>
<li>       scr.setColor(Color.RED);//设置小圆颜色  </li>
<li>       scr.fillOval(90,ypos,80,80); //绘制小圆  </li>
<li>    }  </li>
<li>    public static void main(String[] args)  </li>
<li>    {  </li>
<li>       DoubleBuffer DB=new DoubleBuffer();//创建主类的对象  </li>
<li>       DB.addWindowListener(new WindowAdapter()//添加窗口关闭处理函数  </li>
<li>       {  </li>
<li>           public void windowClosing(WindowEvent e)  </li>
<li>           {  </li>
<li>              System.exit(0);  </li>
<li>           }});  </li>
<li>    }  </li>
<li>}  </li>
<li>class paintThread extends Thread//绘图线程类  </li>
<li>{  </li>
<li>    DoubleBuffer DB;  </li>
<li>       public paintThread(DoubleBuffer DB) //构造函数  </li>
<li>       {  </li>
<li>           this.DB=DB;  </li>
<li>       }  </li>
<li>       public void run()//重载run()函数  </li>
<li>       {  </li>
<li>           while(true)//线程中的无限循环  </li>
<li>           {  </li>
<li>              try{  </li>
<li>                  sleep(30); //线程休眠30ms  </li>
<li>                  }catch(InterruptedException e){}  </li>
<li>              DB.ypos+=5; //修改小圆左上角的纵坐标  </li>
<li>              if(DB.ypos&gt;300) //小圆离开窗口后重设左上角的纵坐标  </li>
<li>                  DB.ypos=-80;  </li>
<li>              DB.repaint();//窗口重绘  </li>
<li>           }  </li>
<li>       }  </li>
<li>}  </li>
</ol>
<p>编译、运行上述例子程序后，我们会看到窗体中有一个从上至下匀速运动的小圆，但仔细观察，你会发现小圆会不时地被白色的不规则横纹隔开，即所谓的屏幕闪烁，这不是我们预期的结果。</p>
<p>这种闪烁是如何出现的呢？</p>
<p>首先我们分析一下这段代码。DoubleBuffer的对象建立后，显示窗口，程序首先自动调用重载后的paint(Graphics g)函数，在窗口上绘制了一个小圆，绘图线程启动后，该线程每隔30ms修改一下小圆的位置，然后调用repaint()函数。</p>
<p>注意，<strong>这个</strong><strong>repaint()函数并不是我们重载的，而是从Frame类继承而来的。它先调用update(Graphics<br />
 g)函数，update(Graphics g)再调用paint(Graphics g)函数</strong>。问题就出在update(Graphics<br />
 g)函数，我们来看看这个函数的源代码：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public void update(Graphics g)  </li>
<li>{  </li>
<li>if (isShowing())  </li>
<li>{  </li>
<li>        if (! (peer instanceof LightweightPeer))  </li>
<li>{  </li>
<li>             g.clearRect(0, 0, width, height);  </li>
<li>         }  </li>
<li>        paint(g);  </li>
<li>    }  </li>
<li>}  </li>
</ol>
<p>以上代码的意思是：<strong>（如果该组件是轻量组件的话）先用背景色覆盖整个组件，然后再调用</strong><strong>paint(Graphics g)</strong><strong>函数，重新绘制小圆</strong>。这样，我们每次看到的都是一个在新的位置绘制的小圆，前面的小圆都被背景色覆盖掉了。这就像一帧一帧的画面匀速地切换，以此来实现动画的效果。</p>
<p>    但是，正是这种先用背景色覆盖组件再重绘图像的方式导致了闪烁。在两次看到不同位置小圆的中间时刻，总是存在一个在短时间内被绘制出来的空白画面（颜色取背景色）。但即使时间很短，如果重绘的面积较大的话花去的时间也是比较可观的，这个时间甚至可以大到足以让闪烁严重到让人无法忍受的地步。</p>
<p>    另外，用paint(Graphics g)函数在屏幕上直接绘图的时候，由于执行的语句比较多，程序不断地改变窗体中正在被绘制的图象，会造成绘制的缓慢，这也从一定程度上加剧了闪烁。</p>
<p>    就像以前课堂上老师用的旧式的幻灯机，放完一张胶片，老师会将它拿下去，这个时候屏幕上一片空白，直到放上第二张，中间时间间隔较长。当然，这不是在放动画，但上述闪烁的产生原因和这很类似。</p>
<p>二、问题的解决</p>
<p>知道了闪烁产生的原因，我们就有了更具针对性的解决闪烁的方案。已经知道update(Graphics g)是造成闪烁的主要原因，那么就从这里入手。</p>
<p>（1）尝试这样重载update(Graphics g)函数（基于代码段一修改）：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public void update(Graphics scr)  </li>
<li>{  </li>
<li>    paint(scr);  </li>
<li>}  </li>
</ol>
<p>以上代码在重绘小圆之前没有用背景色重绘整个画面，而是直接调用paint(Graphics g)函数，这就从根本上避免了上述的那幅空白画面。</p>
<p>    看看运行结果，闪烁果然消除了！但是更大的问题出现了，不同时刻绘制的小圆重叠在一起形成了一条线！这样的结果我们更不能接受了。为什么会这样呢？仔细分析一下，重载后的update(Graphics g)函数中没有了任何清屏的操作，每次重绘都是在先前已经绘制好的图象的基础上，当然会出现重叠的现象了。</p>
<p>2）使用双缓冲：</p>
<p>这是本文讨论的重点。所谓双缓冲，就是在内存中开辟一片区域，作为后台图象，程序对它进行更新、修改，绘制完成后再显示到屏幕上。  </p>
<p>1、重载paint(Graphics g)实现双缓冲：</p>
<p>    这种方法要求我们将双缓冲的处理放在paint(Graphics g)函数中，那么具体该怎么实现呢？先看下面的代码（基于代码段一修改）：</p>
<p>在DoubleBuffer类中添加如下两个私有成员：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>private Image iBuffer;  </li>
<li>private Graphics gBuffer;  </li>
<li>//重载paint(Graphics scr)函数：  </li>
<li>public void paint(Graphics scr)  </li>
<li>{  </li>
<li>    if(iBuffer==null)  </li>
<li>    {  </li>
<li>       iBuffer=createImage(this.getSize().width,this.getSize().height);  </li>
<li>       gBuffer=iBuffer.getGraphics();  </li>
<li>    }  </li>
<li>    gBuffer.setColor(getBackground());  </li>
<li>    gBuffer.fillRect(0,0,this.getSize().width,this.getSize().height);  </li>
<li>   gBuffer.setColor(Color.RED);  </li>
<li>   gBuffer.fillOval(90,ypos,80,80);  </li>
<li>    scr.drawImage(iBuffer,0,0,this);  </li>
<li>}  </li>
</ol>
<p>分析上述代码：我们首先添加了两个成员变量iBuffer和gBuffer作为缓冲（这就是所谓的双缓冲名字的来历）。在paint(Graphics<br />
 scr)函数中，首先检测如果iBuffer为null，则创建一个和屏幕上的绘图区域大小一样的缓冲图象，再取得iBuffer的Graphics类型的对象的引用，并将其赋值给gBuffer，然后对gBuffer这个内存中的后台图象先用fillRect(int,int,int,int)清屏，再进行绘制操作，完成后将iBuffer直接绘制到屏幕上。</p>
<p>    这段代码看似可以完美地完成双缓冲，但是，运行之后我们看到的还是严重的闪烁！为什么呢？回想上文所讨论的，问题还是出现在update(Graphics g)函数！这段修改后的程序中的update(Graphics<br />
 g)函数还是我们从父类继承的。在update(Graphics g)中，clearRect(int,int,int,int)对前端屏幕进行了清屏操作，而在paint(Graphics<br />
 g)中，对后台图象又进行了清屏操作。那么如果保留后台清屏，去掉多余的前台清屏应该就会消除闪烁。所以，我们只要按照（1）中的方法重载update(Graphics g)即可：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public void update(Graphics scr)  </li>
<li>{  </li>
<li>    paint(scr);  </li>
<li>}  </li>
</ol>
<p>这样就避开了对前端图象的清屏操作，避免了屏幕的闪烁。虽然和（1）中用一样的方法重载update(Graphics g)，但（1）中没有了清屏操作，消除闪烁的同时严重破坏了动画效果，这里我们把清屏操作放在了后台图象上，消除了闪烁的同时也获得了预期的动画效果。</p>
<p>2、重载update(Graphics g)实现双缓冲：</p>
<p>    这是比较传统的做法。也是实际开发中比较常用的做法。我们看看实现这种方法的代码（基于代码段一修改）：</p>
<p>在DoubleBuffer类中添加如下两个私有成员：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>private Image iBuffer;  </li>
<li>private Graphics gBuffer;  </li>
<li>//重载paint(Graphics scr)函数：  </li>
<li>public void paint(Graphics scr)  </li>
<li>{  </li>
<li>    scr.setColor(Color.RED);  </li>
<li>    scr.fillOval(90,ypos,80,80);  </li>
<li>}  </li>
</ol>
<p>重载update(Graphics scr)函数：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/kai_wei_zhang/article/details/8120382#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public void update(Graphics scr)  </li>
<li>{  </li>
<li>    if(iBuffer==null)  </li>
<li>    {  </li>
<li>       iBuffer=createImage(this.getSize().width,this.getSize().height);  </li>
<li>       gBuffer=iBuffer.getGraphics();  </li>
<li>    }  </li>
<li>       gBuffer.setColor(getBackground());  </li>
<li>       gBuffer.fillRect(0,0,this.getSize().width,this.getSize().height);  </li>
<li>       paint(gBuffer);  </li>
<li>       scr.drawImage(iBuffer,0,0,this);  </li>
<li>}  </li>
</ol>
<p>分析上述代码：我们把对后台图象的创建、清屏以及重绘等一系列动作都放在了update(Graphicsscr)函数中，而paint(Graphics g)函数只是负责绘制什么样的图象，以及怎样绘图，函数的最后实现了后台图象向前台绘制的过程。</p>
<p>运行上述修改后的程序，我们会看到完美的消除闪烁后的动画效果。就像在电影院看电影，每张胶片都是在后台准备好的，播放完一张胶片之后，下一张很快就被播放到前台，自然不会出现闪烁的情形。</p>
<p>    为了让读者能对双缓冲有个全面的认识现将上述双缓冲的实现概括如下：</p>
<p>（1）定义一个Graphics对象gBuffer和一个Image对象iBuffer。按屏幕大小建立一个缓冲对象给iBuffer。然后取得iBuffer的Graphics赋给gBuffer。此处可以把gBuffer理解为逻辑上的缓冲屏幕，而把iBuffer理解为缓冲屏幕上的图象。</p>
<p>（2）在gBuffer（逻辑上的屏幕）上用paint(Graphics<br />
 g)函数绘制图象。</p>
<p>（3）将后台图象iBuffer绘制到前台。</p>
<p>以上就是一次双缓冲的过程。注意，将这个过程联系起来的是repaint()函数。paint(Graphics g)是一个系统调用语句，不能由程序员手工调用。只能通过repaint()函数调用。</p>
<p>三、问题的扩展</p>
<p>1、关于闪烁的补充：</p>
<p>其实引起闪烁的不仅仅是上文提到的那样，多种物理因素也可以引起闪烁，无论是CRT显示器还是LCD显示器都存在闪烁的现象。本文只讨论软件编程引起的闪烁。但是即使双缓冲做得再好，有时也是会有闪烁，这就是硬件方面的原因了，我们只能修改程序中的相关参数来降低闪烁（比如让画面动得慢一点），而不是编程方法的问题。</p>
<p>2、关于消除闪烁的方法的补充：</p>
<p>    上文提到的双缓冲的实现方法只是消除闪烁的方法中的一种。如果在swing中，组件本身就提供了双缓冲的功能，我们只需要进行简单的函数调用就可以实现组件的双缓冲，在awt中却没有提供此功能。另外，一些硬件设备也可以实现双缓冲，每次都是先把图象画在缓冲中，然后再绘制在屏幕上，而不是直接绘制在屏幕上，基本原理还是和文中的类似的。还有其他用软件实现消除闪烁的方法，但双缓冲是个简单的、值得推荐的方法。</p>
<p>2、关于双缓冲的补充：</p>
<p>双缓冲技术是编写J2ME游戏的关键技术之一。双缓冲付出的代价是较大的额外内存消耗。但现在节省内存已经不再是程序员们考虑的最首要的问题了，游戏的画面在游戏制作中是至关重要的，所以以额外的内存消耗换取程序质量的提高还是值得肯定的。</p>
<p>3、双缓冲的改进：</p>
<p>有时动画中相邻的两幅画面只是有很少部分的不同，这就没必要每次都对整个绘图区进行清屏。我们可以对文中的程序进行修改，使之每次只对部分屏幕清屏，这样既能节省内存，又能减少绘制图象的时间，使动画更加连贯！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 21:55:25</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>java的双缓冲技术的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKY6Dnp.html" rel="bookmark">java-关于JAVA绘图双缓冲技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于JAVA绘图双缓冲技术 package two; import java.awt.Color; import java.awt.Graphics; import java.awt.Image; import java.awt.Rectangle; import javax.swing.JFrame; public class G1P2 extends JFrame{ final int WIDTH = 900,HEIGHT = 650; double p1Speed = 0.5,p			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVnmqkz.html" rel="bookmark">java中的双缓冲技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				毕业设计有个远程协助功能,得到对方的屏幕后,老是会闪,很是不爽,今天用java的双缓冲技术解决了.代码如下,本类重写了Swing中的JLabel,当Label重绘时,会默认的调用它的update方法,主要用于清除界面,然后update方法会调用paint方法,再把界面画上去,所以我现在update方法中创建了一个Image和Graphics对象Image off_screen_buf和off_screen_gc同时设置其大小和MyLabel对象的大小一样,用于把要画的东东先绘制到后台内存中,然后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mlm6aYp.html" rel="bookmark">【求助】关于Java中的双缓冲技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我尝试写一个人物行走的动画.我使用了双缓冲技术,但是屏幕仍然会闪烁,希望大家能够帮我找到其中的错误.代码如下:(1)精灵类packagesprite;importjava.awt.*;importjava.awt.image.*;importjavax.swing.*;publicclassSprite{publicintm_posX=0,m_posY=0;privateImagepic[]=null;privateintmPlayID=0;booleanmFacus=true;pub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLEejM.html" rel="bookmark">双缓冲技术实现Android 画板应用&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是双缓冲技术?双缓冲技术就是当用户操作界面完成后,会有一个缓冲区保存用户操作的结果. 为什么要使用双缓冲技术?拿Android 游戏开发来说,界面贞每次都是全部重画的,也就说画了新的,旧的就没了,所以需要使用双缓冲技术保存之前的内容. 如何实现双缓冲?使用一个Bitmap对象保留之前的画布即可. package com.example.phonegaptest; import android.content.Context; import android.graphics.Bitmap; i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmJWAz.html" rel="bookmark">Android采用双缓冲技术实现画板&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例为大家分享了Android实现画板的具体代码,采用的技术是双缓冲技术,供大家参考,具体内容如下 1.双缓冲技术的概念 所谓的双缓冲技术其实很简单,当程序需要在指定的View上进行绘制时,程序并不需要直接绘制到该View组件,而是先绘制到一个内存中的Bitmap图片上(就是缓冲),等内存中的Bitmap绘制好之后,再一次性将Bitmap绘制到View组件上. 2.Android采用双缓冲实现画板  实现的思路: 1).定义一个内存中图片,将他作为缓冲区Bitmap cacheBitmap			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlRnDNz.html" rel="bookmark">使用双缓冲技术绘制曲线图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当数据量很大时,绘图可能需要几秒钟甚至更长的时间,而且有时还会出现闪烁现象,为了解决这些问题,可采用双缓冲技术来绘制曲线图. 双缓冲即在内存中创建一个与屏幕绘图区域一致的对象,先将图形绘制到内存中的这个对象上,再一次性将这个对象上的图形拷贝到屏幕上,这样能大大加快绘图的速度.双缓冲实现过程如下: 1.在内存中创建与画布一致的缓冲区 BufferBmp=new Graphics::TBitmap(); BufferBmp-&gt;Canvas-&gt;Handle=CreateCompatibleDC(Ca			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKl71p.html" rel="bookmark">使用双缓冲技术实现Android画板应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				双缓冲技术就是当用户操作界面完成后,会有一个缓冲区保存用户操作的结果. 为什么要使用双缓冲技术?拿Android 游戏开发来说,界面贞每次都是全部重画的,也就说画了新的,旧的就没了,所以需要使用双缓冲技术保存之前的内容. 如何实现双缓冲?使用一个Bitmap对象保留之前的画布即可. package com.example.phonegaptest; import android.content.Context; import android.graphics.Bitmap; import and			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8YgP3z.html" rel="bookmark">MFC小游戏，使用双缓冲技术但是有些位图无法释放，导致GDI泄露</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 MFC小游戏,使用双缓冲技术但是有些位图无法释放,导致GDI泄露 用MFC写了一个类似于魔塔的小游戏,但是发现会产生GDI泄露,运行一段时间就会崩掉,但是有些位图文件不能通过deleteObject释放,自己搞不太明白,请教一下各位. 解决方案 hero等对象应该是成员变量吧.从代码来看,hero中的picture载入的图片是固定的,那么完全没有必要在OnPaint函数中进行重复调用,完全是浪费,应该将这些代码放到hero对象初始化的地方,一次性完成就可以了. 另外,cDC指针最好也R			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx73qOb.html" rel="bookmark">android双缓冲技术实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android中的SurfaceView类就是双缓冲机制.因此,在进行Android游戏开发时应尽量使用SurfaceView而不要使用View,这样的话效率较高,并且SurfaceView的功能也更加完善.为了更容易的了解双缓冲技术,下面介绍用View实现双缓冲的方法. 在此需要说明一下,双缓冲的核心技术就是先通过setBitmap方法将要绘制的所有的图形绘制到一个Bitmap上,然后再来调用drawBitmap方法绘制出这个Bitmap,显示在屏幕上.其具体的实现代码如下: 先贴出View类			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3k0Ab.html" rel="bookmark" class="title">java中访问数据库操作</a>
					<div>
						访问|数据|数据库  首先要装好驱动.不要像我,折腾了好几个小时的mysql访问.后面才发现犯了一个最基本的也是最致命的错误--没有装驱动!想想都觉得汗颜色.       几种常见的数据访问方式如下: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM69nWb.html" rel="bookmark" class="title">sql server 安装出现&OpenCurlyDoubleQuote;以前的某个程序安装&period;&period;&period;&rdquo;的解决办法</a>
					<div>
						笔者昨日在自己电脑上安装sql server 数据库,提示错误&quot;以前的某个程序安装已在安装的计算机上创建挂起的文件操作.运行安装程序之前必须重新启动计算机&quot;由于是第一次安装.就老老 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw4emb.html" rel="bookmark" class="title">Vista操作系统下如何安装下安装及配置PHP环境</a>
					<div>
						下载PHP 5后解压缩文件到C:\PHP 目录下然后将根目录下的DLL文件拷贝到c:\windows\system32下然后将php.ini-dist改为 php.ini将extension_dir  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMldlVM.html" rel="bookmark" class="title">山谷挽歌（三）再见&comma;李闯王开复</a>
					<div>
						在写篇这篇blog之前,个人首先感谢两位姓王的人:王永民和王选. 王永民是五笔字型输入法的开发者,小蛇从92年开始用五笔,第一段用键盘敲出的文字就是模仿黄夏留教授的语录,至今十五年矣,其间写下的字节也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apX86Lp.html" rel="bookmark" class="title">override deal with window closing in database application</a>
					<div>
						application|window In the database application development, the programmer should often deal with on ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWAaXz.html" rel="bookmark" class="title">snoopy 强大的PHP采集类使用实例代码</a>
					<div>
						下载地址: http://www.jb51.net/codes/33397.html Snoopy的一些特点: 1抓取网页的内容 fetch 2 抓取网页的文本内容 (去除HTML标签) fetcht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwdynb.html" rel="bookmark" class="title">黑链生意改头换面卷土重来</a>
					<div>
						友情链接还有用吗?毋庸置疑,肯定是有效果的,百度只是申明那些&quot;不具有推荐意义的链接&quot;是违反搜索引擎原则的.因此,具有内容相关性,权重很高的友情链接,在搜索引擎中对网站的投票价值肯定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2koob.html" rel="bookmark" class="title">客户端&lpar;CSS&rpar;解决自动截取字符串长度并以&period;&period;&period;代替</a>
					<div>
						通常的我们在读取文章标题的时候,遇到字符过多,都是通过程序在SERVER端截取一定的字符数,然后添加...来实现标题长度截取的.其实我们也可以通过CSS来控制. 实列如下: .title { widt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balRRNz.html" rel="bookmark" class="title">LLsMP系列教程之三：Litespeed开启htaccess伪静态方法</a>
					<div>
						如果我们的VPS是用LLsMP架构的话,默认的htaccess伪静态是支持比如wordpress,discuz等常规的CMS.但是有些时候,有些程序我们在安装后,或者说后台启动了伪静态功能,前台点击页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7WO4b.html" rel="bookmark" class="title">Win8系统进程System&period;exe占用100&percnt;磁盘怎么办</a>
					<div>
						  Win8系统进程System.exe占用100%磁盘怎么办 1.因为这里需要设置虚拟内存,至于如果寻找到下图设置界面读者可以参考Win8如何巧设虚拟内存扩大存储空间一文. 这里在高级选项卡之中点击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wnkqp.html" rel="bookmark" class="title">Photoshop给外景美女加上淡美的秋季黄褐色</a>
					<div>
						  素材图片的主色比较淡,调色的时候先把主色转为橙红色,暗部增加一点褐色,高光部分再增加一些淡黄色;然后设定好光源方向,给图片增加淡淡的阳光效果即可. 原图 最终效果 1.打开素材图片,创建可选颜色调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjgBLb.html" rel="bookmark" class="title">Win7重启系统后USB3&period;0无法使用的解决方法</a>
					<div>
						  USB3.0和2.0的传输速度相差很大,现在很多最流主板都配备了3.0的USB端口,一般情况下只要外接设备支持3.0的端口我们就会使用3.0的接口传输数据,不过有部分用户反映,在win7系统下3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7r80M.html" rel="bookmark" class="title">酷我k歌怎么听不到自己的声音</a>
					<div>
						  1.用酷我K歌唱歌没有自己的声音? 请检查您的麦克风是否能正常使用,若正常,您勾选音效视频内的&quot;听到自唱声音&quot;就可以在唱歌的过程中听到自己的声音. (注:开启该功能后若使用的是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYlGWM.html" rel="bookmark" class="title">PHP中几个可以提高运行效率的代码写法、技巧分享&lowbar;php实例</a>
					<div>
						废话不多说,直接看代码示例. 一.遍历数组 在遍历数组中注意count的使用次数,不要每次都去计算数组长度 效率慢的写法 复制代码 代码如下: &lt;?php   $array = array(1, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW21njb.html" rel="bookmark" class="title">stm32-keil在配置STemWin时出现错误</a>
					<div>
						问题描述 keil在配置STemWin时出现错误 Error: L6218E: Undefined symbol GUI_X_GetTaskId (referred from gui_task.o). ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7O6op.html" rel="bookmark" class="title">传统企业如何进行互联网转型？中石化的秘诀看这里</a>
					<div>
						在2016杭州云栖大会的第二日,石化盈科信息技术有限责任公司互联网及协同应用副总经理刘依群在企业互联网转型峰会分享了&lt;中石化互联网转型思考与实践&gt;,他主要介绍了搭建统一电子商务及客户关系管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P7Wqp.html" rel="bookmark" class="title">dsd酸-学习完 c语言 基础 怎么去 进阶 学习什么</a>
					<div>
						问题描述 学习完 c语言 基础 怎么去 进阶 学习什么 学习完 c语言 基础 怎么去 进阶 学习什么 介绍一些书 来看看 解决方案 c++哥们,有了基础想学啥都行,主要看兴趣哦. 解决方案二: &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEQ93z.html" rel="bookmark" class="title">pytest-python自动化测试的问题，比较两个波形文件，能用方差直接比较么？</a>
					<div>
						问题描述 python自动化测试的问题,比较两个波形文件,能用方差直接比较么? 主要是有两个波形文件,它们由不同的方式生成,一个是期望值,一个是要测试的,我是想知道,如果写了一个方差的函数varian ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kXwoM.html" rel="bookmark" class="title">des-话说3DES加密&comma;如何修改成24位密钥&comma;C语言版本</a>
					<div>
						问题描述 话说3DES加密,如何修改成24位密钥,C语言版本 假设密钥:1234567812345678ABCDEFGH -- 24 如果进行3DES加密. 我网上找到的版本全是64位的 解决方案 参 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBm9PM.html" rel="bookmark" class="title">Go语言map映射的基本操作</a>
					<div>
						对比python, java都有对应的字典类型及哈希类型. package main import ( &quot;fmt&quot; ) //main is the entry of the pro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Rre7z.html" rel="bookmark" class="title">中小企业招聘难：知名度及品牌成首要原因</a>
					<div>
						每经记者 陈莉莉 北京报道 日前,科锐国际人才资源公司(简称:科锐国际)与某大型工业园区联手进行调研,发布了&lt;中小企业招聘现状与趋势调查&gt;报告. 调查中,有47%的调查对象认为缺乏知名度和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoeq0M.html" rel="bookmark" class="title">Java最新学习资源共享区</a>
					<div>
						问题描述 零基础,黑马入学辅导班,15天突击Java,黑马入学,企业面试统统秒杀,详情 解决方案 解决方案二:感谢分享,建议这样的帖子发非技术区吧解决方案三:引用1楼huxiweng的回复: 感谢分享 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrwYEp.html" rel="bookmark" class="title">jQuery向下滚动即时加载内容实现的瀑布流效果&lowbar;php实例</a>
					<div>
						下拉滚动条或鼠标滚轮滚动到页面底部时, 动态即时加载新内容. 后台用 json 传输数据, 示例程序中只写了示例数组.数据也只设置了两个属性, 需根据实际应用改写. 页面用了 ul li 做为容器,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdGOQM.html" rel="bookmark" class="title">如何提高个人站长创业成功几率</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 商业网站为什么比个人网站易 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YdaDp.html" rel="bookmark" class="title">7分钟教你学会SEO 带你了解优化基础知识</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 1.结构 - 网络语言的使用,导航和丰富的媒体都对搜索引擎是否能够抓取和理解你的网站主题的影响. 2.内容 - 搜索引擎蜘蛛真的很愚蠢.您的网页内容需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YX8Wp.html" rel="bookmark" class="title">中序遍历-为什么二叉树的中序非递归算法无法实现</a>
					<div>
						问题描述 为什么二叉树的中序非递归算法无法实现 // 实验三.cpp : 定义控制台应用程序的入口点. // #include &quot;stdafx.h&quot; #include using  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4BxZb.html" rel="bookmark" class="title">Dubbo入门简单示例</a>
					<div>
						   之前用过EJB做分布式系统,前段时间跟人闲聊,发现还是Dubbo+ZK用的比较多,so,自己玩玩儿.     先安装一个zk作为服务注册中心,之后,建个maven工程,pom里面加入如下配置:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmR5ABz.html" rel="bookmark" class="title">张江企业打造&OpenCurlyDoubleQuote;互联网第四屏幕&rdquo;</a>
					<div>
						本报讯 (记者 王志彦)轻点手机屏幕,电视机上便能呈现出手机中的照片,这种能够在多种屏幕上同步显示视频.音频.文档等分享内容的信息传输新技术日前在张江被攻克.负责http://www.aliyun.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlWARYb.html" rel="bookmark" class="title">未来纽约 7500 个电话亭将悉数改为 Wi-Fi 热点</a>
					<div>
						近日,纽约市安装了首个千兆公共 WiFi,并将该项目命名为 LinkNYC. 其实这个项目早在 2014年11月 便公诸于世了,该热点将基于标准的电话亭做改造,使用升级过的架构提供千兆 WiFi 接入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zw552vM.html" rel="bookmark" class="title">《可穿戴创意设计：技术与时尚的融合》一一1&period;3　可穿戴设备和艺术</a>
					<div>
						1.3 可穿戴设备和艺术巴黎艺术学院和声学教授Theodore Dubois于1883年首演了他的电子芭蕾舞剧&lt;法兰多尔&gt;.在这部芭蕾舞剧中,舞者的前额佩戴电灯,电池藏在服装深处.当舞者触 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
